/*
 * (c) Copyright 2004 Frank Yeah (pwipwi@ms66.hinet.net)
 *
 * To anyone who acknowledges that this file is provided "AS IS"
 * without any express or implied warranty:
 *     permission to use, copy, modify, and distribute this file
 * for any purpose is hereby granted without fee, provided that
 * the above copyright notice and this notice appears in all
 * copies. Frank Yeah makes no representations about the suitability
 * of this software for any purpose.
 */
//---------------------------------------------------------------------------

#include <stdlib.h>
#include <conio.h>
#pragma hdrstop

#include "arbi.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
arbitrary::arbitrary(const arbitrary& value)
{
*this = value;
}
//---------------------------------------------------------------------------
arbitrary::arbitrary(const char *value)
{
num_array.resize(0);
if(strlen(value) < 9)
        {
        this->number = atol(value);
        return;
        }
else
        this->number = 0;
this->sign = true;
this->number = 0;
for(int ia = 0;value[ia] != 0;ia++)
    if(::isdigit(value[ia]))
        {
        *this *= 10;
        *this += (long)(value[ia]-'0');
        }
sign = (value[0] != '-');
}
//---------------------------------------------------------------------------
arbitrary::arbitrary(double value)
{
double temp;
if(value < LONG_MAX / 2 && value > LONG_MIN / 2)
        {
        number = value;
        return;
        }
sign = (value >=0);
value = ::floor(::fabs(-value));
while(value >= 1 )
    {
    temp = floor(value / (double)65536) * (double)65536;
    this->num_array.push_back((unsigned short)(value-temp));
    value /= (double)65536;
    }
}
//---------------------------------------------------------------------------
arbitrary& arbitrary::operator=(const arbitrary& value)
{
if(&value == this)
        return *this;
if(value.num_array.size() == 0)
        {
        this->number = value.number;
        if(num_array.size() != 0)
                num_array.resize(0);
        return *this;
        }
this->number = 0;
this->num_array = value.num_array;
this->sign = value.sign;
return *this;
}
//---------------------------------------------------------------------------
arbitrary& arbitrary::operator=(long value)
{
number = value;
if(num_array.size() != 0)
        num_array.resize(0);
return *this;
}
//---------------------------------------------------------------------------
arbitrary& arbitrary::operator-(void)
{
if(this->num_array.size() == 0)
        number = -number;
else
        sign = !sign;
return *this;
}
//---------------------------------------------------------------------------
void arbitrary::debug(void)
{
if(num_array.size() == 0)
        {
        cout << number << endl;
        return;
        }
if(!sign)
        cout << "-";
for(unsigned int i = 0;i < num_array.size();i++)
        {
        cout << (unsigned long)num_array[i] << ':';
        }
}
//---------------------------------------------------------------------------
void arbitrary::transform(void)
{
bool temp = number >= 0;
transform((unsigned long)formula::abs(number));
sign = temp;
}
//---------------------------------------------------------------------------
void arbitrary::transform(unsigned long value)
{
number = 0;
num_array.resize(2);
num_array[0] = value & 0xffff;
num_array[1] = value >> 16;
 sign = true;
}
//---------------------------------------------------------------------------
unsigned long arbitrary::to_unsigned_long(void) const
{
unsigned long value = 0;
if(num_array.size() == 0)
        return formula::abs(number);
if(num_array.size() > 1)
        value = num_array[1];
value <<= 16;
value += num_array[0];
return value;
}
//---------------------------------------------------------------------------
void arbitrary::check_plus_safe(void)
{
if(this->num_array.size() != 0)
        return;
if(number >= (LONG_MAX>>1) ||
        number <= (LONG_MIN >> 1))
        transform();
}
//---------------------------------------------------------------------------
void arbitrary::check_times_safe(void)
{
if(this->num_array.size() != 0)
        return;
if(number > SHRT_MAX ||
        number < SHRT_MIN)
        transform();
}
//---------------------------------------------------------------------------
void arbitrary::check_too_small(void)
{
while(this->num_array[this->num_array.size()-1] == 0 && this->num_array.size() > 1)
        this->num_array.pop_back();
if(this->num_array.size() == 1)
        {
        number = this->num_array[0];
        this->num_array.pop_back();
        if(!sign)
                number = -number;
        }
}
//---------------------------------------------------------------------------
void arbitrary::plus_unsigned(const arbitrary& value)
{
unsigned long temp = 0;
if(this->num_array.size() < value.num_array.size())
        this->num_array.resize(value.num_array.size(),0);
for(unsigned int i = 0;i < this->num_array.size();i++)
        {
        temp += this->num_array[i];
        if(i < value.num_array.size())
                temp += value.num_array[i];
        this->num_array[i] = (unsigned short)(temp & 0xffff);
        temp >>= 16;
        }
if(temp != 0)
        this->num_array.push_back(temp);
}
//---------------------------------------------------------------------------
void arbitrary::minus_unsigned(const arbitrary& value)
{
unsigned long temp = 1;
if(this->num_array.size() < value.num_array.size())
        this->num_array.resize(value.num_array.size(),0);
for(unsigned int i = 0;i < this->num_array.size();i++)
    {
    temp += 0xffffL;
    temp += this->num_array[i];
    if(i < value.num_array.size())
        temp -= value.num_array[i];
    this->num_array[i] = (unsigned short)(temp & 0xffffL);
    temp >>= 16;
    }
if(temp != 1)
    {
    for(unsigned int i = 0;i < this->num_array.size();i++)
        this->num_array[i] = (unsigned short)~this->num_array[i];
    if(sign)
        *this += 1;
    else
        *this -= 1;
    sign = !sign;
    }
check_too_small();
}
//---------------------------------------------------------------------------
void arbitrary::times_unsigned(const arbitrary& value2)
{
arbitrary value1 = *this;
unsigned __int64 temp = 0;
unsigned __int64 num;
if(value2.num_array.size() > 1)
        this->num_array.resize(value1.num_array.size()+value2.num_array.size()-1,0);
for(unsigned int i = 0; i < this->num_array.size();i++)
    {
    for(int i1 = 0,i2 = i;i1 < (int)value1.num_array.size() && i2 >= 0;i1++,i2--)
        {
        if(i2 >= (int)value2.num_array.size())
            {
            i2 = value2.num_array.size();
            i1 = i-value2.num_array.size();
            continue;
            }
        num = (unsigned __int64)value1.num_array[i1];
        num *= (unsigned __int64)value2.num_array[i2];
        temp += num;
        }
    this->num_array[i] = temp & 0xffffL;
    temp >>= 16;
    }
if(temp != 0)
        this->num_array.push_back(temp);
}
//---------------------------------------------------------------------------
void arbitrary::divide_unsigned(const arbitrary& value2,arbitrary& mod)
{
arbitrary value1;
unsigned int shift;
unsigned long temp;
value1 = *this;

cout << *this << "/" << value2 << endl;
getche();

shift = value1.num_array.size() - value2.num_array.size();
if(value2.num_array[value2.num_array.size()-1] >
        value1.num_array[num_array.size()-1]
                && shift > 0)
    {
    temp = ((unsigned long)value1.num_array[value1.num_array.size()-1]) << 16;
    temp += (unsigned long)value1.num_array[value1.num_array.size()-2];
    temp /= value2.num_array[value2.num_array.size()-1];
    shift--;
    }
else
    {
    temp = value1.num_array[value1.num_array.size()-1];
    temp /= value2.num_array[value2.num_array.size()-1];
    }

this->num_array.resize(0);
this->num_array.resize(shift+1,0);
this->num_array[this->num_array.size()-1] = temp;   // new quo

mod = value2;
if(shift)
    mod.num_array.insert(mod.num_array.begin(),shift,0);
if(temp != 1)
    mod.times_unsigned(temp);
mod.sign = value1.sign;

cout << "q=" << temp << endl;
cout << "mod=" << mod << endl;
getche();
value1 -= mod;
cout << "value1=" << value1 << endl;
getche();
value1.divide(value2,mod);

*this += value1;
cout << "*this += value1 = " << *this << endl;
getche();

check_too_small();
mod.check_too_small();
}
//---------------------------------------------------------------------------
void arbitrary::plus_unsigned(unsigned long value)
{
arbitrary temp;
if(value <= 65535L)
        return plus_unsigned((unsigned short)value);
temp.transform(value);
this->plus_unsigned(temp);
}
//---------------------------------------------------------------------------
void arbitrary::minus_unsigned(unsigned long value)
{
arbitrary temp;
if(value <= 65535L)
        return minus_unsigned((unsigned short)value);
temp.transform(value);
this->minus_unsigned(temp);
}
//---------------------------------------------------------------------------
void arbitrary::times_unsigned(unsigned long value)
{
arbitrary temp;
if(value <= 65535L)
        return times_unsigned((unsigned short)value);
temp.transform(value);
this->times_unsigned(temp);
}
//---------------------------------------------------------------------------
unsigned long arbitrary::divide_unsigned(unsigned long value)
{
arbitrary temp,mod;
if(value <= 65535L)
        return divide_unsigned((unsigned short)value);
temp.transform(value);
this->divide_unsigned(temp,mod);
return mod.to_unsigned_long();
}
//---------------------------------------------------------------------------
void arbitrary::plus_unsigned(unsigned short value)
{
unsigned long temp = value;
for(unsigned int i = 0;i < this->num_array.size() && temp != 0;i++)
        {
        temp += this->num_array[i];
        this->num_array[i] = (unsigned short)(temp & 0xffff);
        temp >>= 16;
        }
if(temp != 0)
        this->num_array.push_back(temp);
}
//---------------------------------------------------------------------------
void arbitrary::minus_unsigned(unsigned short value)
{
unsigned long temp = 0x10000l;
temp -= value;
if(this->num_array.size() > 0)
        {
        temp += this->num_array[0];
        this->num_array[0] = (unsigned short)(temp & 0xffff);
        temp >>= 16;
        }
for(unsigned int i = 1;i < this->num_array.size() && temp != 1;i++)
    {
    temp += 0xffffL;
    temp += this->num_array[i];
    this->num_array[i] = (unsigned short)(temp & 0xffffL);
    temp >>= 16;
    }
if(temp != 1)
    {
    for(unsigned int i = 0;i < this->num_array.size();i++)
        this->num_array[i] = ~this->num_array[i];
    if(sign)
        *this += 1;
    else
        *this -= 1;
    sign = !sign;
    }
check_too_small();
}
//---------------------------------------------------------------------------
void arbitrary::times_unsigned(unsigned short value)
{
unsigned long temp1 = 0;
unsigned long temp2 = 0;
for(unsigned int i = 0;i < this->num_array.size();i++)
        {
        temp1 = this->num_array[i];
        temp1 *= value;
        temp2 += temp1;
        this->num_array[i] = (unsigned short)(temp2 & 0xffff);
        temp2 >>= 16;
        }
if(temp2 != 0)
        this->num_array.push_back(temp2);
}
//---------------------------------------------------------------------------
unsigned short arbitrary::divide_unsigned(unsigned short value)
{
unsigned long temp1 = 0;
unsigned long temp2 = 0;
for(unsigned int i = 0;i < this->num_array.size();i++)
        {
        temp1 <<= 16;
        temp1 += this->num_array[this->num_array.size()-1-i];
        temp2 = temp1;
        temp2 /= value;
        temp1 %= value;
        this->num_array[this->num_array.size()-1-i] = temp2;
        }
check_too_small();
return temp1;
}
//---------------------------------------------------------------------------
bool arbitrary::more_unsigned(const arbitrary& value) const
{
if(value.num_array.size() != this->num_array.size())
        return this->num_array.size() > value.num_array.size();
for(unsigned int i = this->num_array.size();i > 0 ;i--)
        {
        if(this->num_array[i-1] != value.num_array[i-1])
                return this->num_array[i-1] > value.num_array[i-1];
        }
return false;
}
//---------------------------------------------------------------------------
bool arbitrary::less_unsigned(const arbitrary& value) const
{
if(value.num_array.size() != this->num_array.size())
        return this->num_array.size() < value.num_array.size();
for(unsigned int i = this->num_array.size();i > 0 ;i--)
        {
        if(this->num_array[i-1] != value.num_array[i-1])
                return this->num_array[i-1] < value.num_array[i-1];
        }
return false;
}
//---------------------------------------------------------------------------
bool arbitrary::equal_unsigned(const arbitrary& value) const
{
if(value.num_array.size() != this->num_array.size())
        return false;
for(unsigned int i = this->num_array.size();i > 0 ;i--)
        {
        if(this->num_array[i-1] != value.num_array[i-1])
                return false;
        }
return true;
}
//---------------------------------------------------------------------------
bool arbitrary::more_unsigned(unsigned long value) const
{
unsigned long num = 0;
if(this->num_array.size() > 2)
        return true;
if(this->num_array.size() >= 2)
        num = this->num_array[1];
num >>= 16;
if(this->num_array.size() >= 1)
        num += this->num_array[0];
return num > value;
}
//---------------------------------------------------------------------------
bool arbitrary::less_unsigned(unsigned long value) const
{
unsigned long num = 0;
if(this->num_array.size() > 2)
        return false;
if(this->num_array.size() >= 2)
        num = this->num_array[1];
num <<= 16;
if(this->num_array.size() >= 1)
        num += this->num_array[0];
return num < value;
}
//---------------------------------------------------------------------------
bool arbitrary::equal_unsigned(unsigned long value) const
{
unsigned long num = 0;
if(this->num_array.size() > 2)
        return false;
if(this->num_array.size() >= 2)
        num = this->num_array[1];
num <<= 16;
if(this->num_array.size() >= 1)
        num += this->num_array[0];
return num == value;
}
//---------------------------------------------------------------------------
bool arbitrary::operator>(const arbitrary& value) const
{
if(value.num_array.size() == 0 &&
        this->num_array.size() == 0)
        return this->number > value.number;
if(value.num_array.size() == 0)
        return *this > value.number;
if(this->num_array.size() == 0)
        return value < this->number;
if(this->sign != value.sign)
        return this->sign;
if(this->sign)
        return this->more_unsigned(value);
else
        return this->less_unsigned(value);
}
//---------------------------------------------------------------------------
bool arbitrary::operator<(const arbitrary& value) const
{
if(value.num_array.size() == 0 &&
        this->num_array.size() == 0)
        return this->number < value.number;
if(value.num_array.size() == 0)
        return *this < value.number;
if(this->num_array.size() == 0)
        return value > this->number;
if(this->sign != value.sign)
        return value.sign;
if(this->sign)
        return this->less_unsigned(value);
else
        return this->more_unsigned(value);
}
//---------------------------------------------------------------------------
bool arbitrary::operator==(const arbitrary& value) const
{
if(value.num_array.size() == 0 &&
        this->num_array.size() == 0)
        return this->number == value.number;
if(value.num_array.size() == 0)
        return *this == value.number;
if(this->num_array.size() == 0)
        return value == this->number;
if(this->sign != value.sign)
        return false;
return this->equal_unsigned(value);
}
//---------------------------------------------------------------------------
bool arbitrary::operator>(long value) const
{
if(this->num_array.size() == 0)
        return this->number > value;
if((value >= 0) != this->sign)
        return this->sign;
if(this->sign)
        return this->more_unsigned(formula::abs(value));
else
        return this->less_unsigned(formula::abs(value));
}
//---------------------------------------------------------------------------
bool arbitrary::operator<(long value) const
{
if(this->num_array.size() == 0)
        return this->number < value;
if((value >= 0) != this->sign)
        return value >= 0;
if(this->sign)
        return this->less_unsigned(formula::abs(value));
else
        return this->more_unsigned(formula::abs(value));
}
//---------------------------------------------------------------------------
bool arbitrary::operator==(long value) const
{
if(this->num_array.size() == 0)
        return this->number == value;
if((value >= 0) != this->sign)
        return false;
return this->equal_unsigned(formula::abs(value));
}
//---------------------------------------------------------------------------
void arbitrary::operator+=(const arbitrary& value)
{
this->check_plus_safe();
((arbitrary&)value).check_plus_safe();
if(this->num_array.size() == 0 &&
        value.num_array.size() == 0)
        {
        this->number += value.number;
        return;
        }
if(value.num_array.size() == 0)
        {
        *this += value.number;
        return;
        }
if(this->num_array.size() == 0)
        {
        long temp = this->number;
        *this = value;
        *this += temp;
        return;
        }
if(this->sign == value.sign)
        this->plus_unsigned(value);
else
        this->minus_unsigned(value);
}
//---------------------------------------------------------------------------
void arbitrary::operator-=(const arbitrary& value)
{
this->check_plus_safe();
((arbitrary&)value).check_plus_safe();
if(this->num_array.size() == 0 &&
        value.num_array.size() == 0)
        {
        this->number -= value.number;
        return;
        }
if(value.num_array.size() == 0)
        {
        *this -= value.number;
        return;
        }
if(this->num_array.size() == 0)
        {
        long temp = this->number;
        *this = value;
        *this -= temp;
        *this = -(*this);
        return;
        }
if(this->sign == value.sign)
        this->minus_unsigned(value);
else
        this->plus_unsigned(value);
}
//---------------------------------------------------------------------------
void arbitrary::operator*=(const arbitrary& value)
{
this->check_times_safe();
((arbitrary&)value).check_times_safe();
if(this->num_array.size() == 0 &&
        value.num_array.size() == 0)
        {
        this->number *= value.number;
        return;
        }
if(value.num_array.size() == 0)
        {
        *this *= value.number;
        return ;
        }
if(this->num_array.size() == 0)
        {
        long temp = this->number;
        *this = value;
        *this *= temp;
        return;
        }
this->times_unsigned(value);
this->sign = (this->sign == value.sign);
}
//---------------------------------------------------------------------------
void arbitrary::operator/=(const arbitrary& value)
{
arbitrary temp;
if(this->num_array.size() == 0 &&
        value.num_array.size() == 0)
        {
        this->number /= value.number;
        return;
        }
if(value.num_array.size() == 0)
        {
        *this /= value.number;
        return;
        }
if(this->num_array.size() == 0)
        {
        *this = 0;
        return;
        }
this->divide(value,temp);
this->sign = (this->sign == value.sign);
}
//---------------------------------------------------------------------------
void arbitrary::operator%=(const arbitrary& value)
{
arbitrary temp;
if(this->num_array.size() == 0 &&
        value.num_array.size() == 0)
        {
        this->number %= value.number;
        return;
        }
if(value.num_array.size() == 0)
        {
        *this %= value.number;
        return;
        }
if(this->num_array.size() == 0)
        return;
this->divide(value,temp);
*this = temp;
}
//---------------------------------------------------------------------------
void arbitrary::divide(const arbitrary& value,arbitrary& mod)
{
unsigned long temp;
if(this->less_unsigned(value))
        {
        mod = *this;
        *this = 0;
        return;
        }
if(this->num_array.size() <= 2)
        {
        temp = this->to_unsigned_long();
        *this = temp / value.to_unsigned_long();
        mod = temp % value.to_unsigned_long();
        return;
        }
this->divide_unsigned(value,mod);
this->sign = (this->sign == value.sign);
}
//---------------------------------------------------------------------------
void arbitrary::operator+=(long value)
{
this->check_plus_safe();
if(this->num_array.size() == 0)
        {
        if(value > (LONG_MAX>>1) ||
                value < (LONG_MIN>>1))
                {
                swap(value,this->number);
                *this += value;
                return;
                }
        this->number += value;
        return;
        }
if(this->sign == (value >= 0))
        this->plus_unsigned((unsigned long)formula::abs(value));
else
        this->minus_unsigned((unsigned long)formula::abs(value));
}
//---------------------------------------------------------------------------
void arbitrary::operator-=(long value)
{
this->check_plus_safe();
if(this->num_array.size() == 0)
        {
        if(value > (LONG_MAX>>1) ||
                value < (LONG_MIN>>1))
                {
                swap(value,this->number);
                *this -= value;
                this->sign = !(this->sign);
                return;
                }
        this->number -= value;
        return;
        }
if(this->sign == (value >= 0))
        this->minus_unsigned((unsigned long)formula::abs(value));
else
        this->plus_unsigned((unsigned long)formula::abs(value));
}
//---------------------------------------------------------------------------
void arbitrary::operator*=(long value)
{
this->check_times_safe();
if(this->num_array.size() != 0)
        {
        this->times_unsigned((unsigned long)formula::abs(value));
        this->sign = (this->sign == (value >= 0));
        return;
        }
if(value > this->number)
        {
        long temp = value;
        value = this->number;
        this->number = temp;
        *this *= value;
        return;
        }
this->number *= value;
}
//---------------------------------------------------------------------------
void arbitrary::operator/=(long value)
{
long temp;
if(this->num_array.size() == 0)
        {
        this->number /= value;
        return;
        }
this->divide(value);
this->sign = (this->sign == (value >= 0));
}
//---------------------------------------------------------------------------
void arbitrary::operator%=(long value)
{
if(this->num_array.size() == 0)
        {
        this->number %= value;
        return;
        }
*this = this->divide(value);
}
//---------------------------------------------------------------------------
unsigned long arbitrary::divide(long value)
{
unsigned long temp;
if(this->num_array.size() <= 2)
        {
        temp = this->to_unsigned_long();
        *this = temp / value;
        temp %= value;
        return temp;
        }
this->sign = (this->sign == (value >= 0));
return divide_unsigned((unsigned long)value);
}
//---------------------------------------------------------------------------
double arbitrary::to_double(void) const
{
double da = 0;
if(num_array.size() == 0)
        return number;
for(int i = (int)(num_array.size()-1);i >= 0;i--)
    da = da*65536.0+(double)num_array[i];
if(!sign)
    da = -da;
return da;
}
//---------------------------------------------------------------------------
ostream &operator<<(ostream &out,arbitrary value)
{
vector<char> v_string;
long temp;
if(value.num_array.size() == 0)
        {
        out << value.number;
        return out;
        }
for(;;)
        {
        temp = value.divide((unsigned short)10);
        temp += '0';
        v_string.push_back((char)temp);
        if(value == 0)
                break;
        }
reverse(v_string.begin(),v_string.end());
if(!value.sign)out << '-';
for(unsigned int ia = 0;ia < v_string.size();ia++)
    out << v_string[ia];
return out;
}
//---------------------------------------------------------------------------


