/*
 * (c) Copyright 2004 Frank Yeah (pwipwi@ms66.hinet.net)
 *
 * To anyone who acknowledges that this file is provided "AS IS"
 * without any express or implied warranty:
 *     permission to use, copy, modify, and distribute this file
 * for any purpose is hereby granted without fee, provided that
 * the above copyright notice and this notice appears in all
 * copies. Frank Yeah makes no representations about the suitability
 * of this software for any purpose.
 */
//---------------------------------------------------------------------------

#ifndef arbiH
#define arbiH
//---------------------------------------------------------------------------
#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
//---------------------------------------------------------------------------
#include "definition.h"
#include "formula.h"

using namespace std;

class arbitrary{
        protected:
                long number;
                vector<unsigned short> num_array;
                bool sign;
        protected:
                void transform(void);
                void transform(unsigned long);
                unsigned long to_unsigned_long(void) const;
                void check_plus_safe(void);
                void check_times_safe(void);
                void check_too_small(void);
        protected:
                void plus_unsigned(const arbitrary&);
                void minus_unsigned(const arbitrary&);
                void times_unsigned(const arbitrary&);
                void divide_unsigned(const arbitrary&,arbitrary&);
        protected:
                void plus_unsigned(unsigned long);
                void minus_unsigned(unsigned long);
                void times_unsigned(unsigned long);
                unsigned long divide_unsigned(unsigned long);

                void plus_unsigned(unsigned short);
                void minus_unsigned(unsigned short);
                void times_unsigned(unsigned short);
                unsigned short divide_unsigned(unsigned short);

        protected:
                bool more_unsigned(const arbitrary&) const;
                bool less_unsigned(const arbitrary&) const;
                bool equal_unsigned(const arbitrary&) const;
                bool more_unsigned(unsigned long) const;
                bool less_unsigned(unsigned long) const;
                bool equal_unsigned(unsigned long) const;


        public:
                arbitrary(long value = 0):number(value),sign(true){;}
                arbitrary(int value):number(value),sign(true){;}
                arbitrary(const char *);
                arbitrary(double);
		arbitrary(const arbitrary&);
		arbitrary& operator=(const arbitrary&);
                arbitrary& operator=(long);
                arbitrary& operator-(void);
        public:
                bool operator>(const arbitrary&) const;
                bool operator<(const arbitrary&) const;
                bool operator==(const arbitrary&) const;

                bool operator>(long) const;
                bool operator<(long) const;
                bool operator==(long) const;
        public:
                void operator+=(const arbitrary&);
                void operator-=(const arbitrary&);
                void operator*=(const arbitrary&);
                void operator/=(const arbitrary&);
                void operator%=(const arbitrary&);
                void divide(const arbitrary&,arbitrary&);
        public:
                void operator+=(long);
                void operator-=(long);
                void operator*=(long);
                void operator/=(long);
                void operator%=(long);
                unsigned long divide(long);
                void operator+=(int value){*this+=(long)value;}
                void operator-=(int value){*this-=(long)value;}
                void operator*=(int value){*this*=(long)value;}
                void operator/=(int value){*this/=(long)value;}
                void operator%=(int value){*this%=(long)value;}
                void operator+=(unsigned int value){*this+=(long)value;}
                void operator-=(unsigned int value){*this-=(long)value;}
                void operator*=(unsigned int value){*this*=(long)value;}
                void operator/=(unsigned int value){*this/=(long)value;}
                void operator%=(unsigned int value){*this%=(long)value;}
        public:
                void debug(void);
                double to_double(void) const;
                friend ostream &operator<<(ostream&,arbitrary);
                };

#endif
