//---------------------------------------------------------------------------

#ifndef formulaH
#define formulaH
#include <algorithm>

//---------------------------------------------------------------------------

namespace formula{

//---------------------------------------------------------------------------
template<typename T>
T abs(T value)
{
return (value > 0)? value : -value;
}
//---------------------------------------------------------------------------
template<typename T1,typename T2>
void exponent(T1 &value,T2 exp)
{
T1 temp = 1;
if(exp < 0)
        {
        temp /= value;
        exponent(temp,-exp);
        return;
        }
if(exp == 0)
        {
        value = temp;
        return ;
        }
while(exp != 1)
        {
        if(exp % 2 != 0)
                {
                exp-=1;
                temp *= value;
                }
        exp /= 2;
        value *= value;
        }
value *= temp;
}
//---------------------------------------------------------------------------
template<typename T>
T gcd(T m,T n)
{
T temp;
if(m < n)
	std::swap(m,n);
if(n == 0)
	return T(0);
while(n!=0)
	{
	temp = m;
	m = n;
	n = temp % n;
	}
return m;
}
//---------------------------------------------------------------------------

template<typename T>
T lcm(T m,T n)
{
T temp;
if(m < n)
	std::swap(m,n);
if(temp == 0)
	return T(0);
temp = gcd(m,n);
m *= n;
m /= temp;
return m;
}

//---------------------------------------------------------------------------

};
#endif
